#!/bin/ksh
###############################################################################
#
#   This Shell Script is for installing CDE Snapins.
#
#   Lexmark International Inc. 1996, 2003
#  
#   (c) Copyright, 2003, Lexmark International Inc. All Rights Reserved.
#
###############################################################################

PRINTF_CMD="/usr/bin/printf"
RM_CMD="/bin/rm"
CP_CMD="/bin/cp"
CHMOD_CMD="/bin/chmod"
CHOWN_CMD="/bin/chown"
MKDIR_CMD="/bin/mkdir"
ECHO_CMD="/bin/echo"
LS_CMD="/bin/ls"
WC_CMD="/usr/bin/wc"
MOVE_CMD="/bin/mv"
UNAME_CMD="/bin/uname"
if [ -x "/bin/awk" ];then     AWK_CMD="/bin/awk"  ; else AWK_CMD="/usr/bin/awk" ; fi

remove_file()
{
	local_file="${1}"

        if [ -f "${local_file}" ]; then
           ${PRINTF_CMD} "Removing ${local_file} ... " 
           ${RM_CMD} -f ${local_file}
           if [ $? -ne 0 ]; then
              ${PRINTF_CMD} "failed.\n" 
           else
              ${PRINTF_CMD} "complete.\n" 
           fi

        fi
}

restore_dt_types()
{
        if [ -d "${HOME}/.dt/types" ]; then
           FP_FILES=`${LS_CMD} ${HOME}/.dt/types/*.fp 2>/dev/null | ${WC_CMD} -l`
           if [ "${FP_FILES}" != "0" ]; then
              ${CP_CMD} ${HOME}/.dt/types/*.fp ${HOME}/.dt/types/fp_dynamic 2>/dev/null
              ${RM_CMD} -f ${HOME}/.dt/types/*.fp 2>/dev/null
           fi
        fi
}

restore_dt_types_fp_dynamic()
{
	if [ -d ${HOME}/.dt/types/fp_dynamic ]; then
		FP_FILES=`${LS_CMD} $HOME/.dt/types/fp_dynamic/*.fp 2>/dev/null | ${WC_CMD} -l`
		if [ $FP_FILES != '0' ]; then
			${CP_CMD} $HOME/.dt/types/fp_dynamic/*.fp $HOME/.dt/types/ 2>/dev/null
			${RM_CMD} -f /$HOME/.dt/types/fp_dynamic/*.fp 2>/dev/null
		fi
	fi
}


Delete() 
{	
	# Restore fp_dynamic
	restore_dt_types_fp_dynamic

        # MarkVision Classic 
	remove_file $HOME/.dt/types/Lexmark.fp
	remove_file $HOME/.dt/types/Lexmark_client.fp
	remove_file /etc/dt/appconfig/types/$LANG/NetMarkVision.dt 2>/dev/null
	remove_file /etc/dt/appconfig/types/$LANG/Lexmark_client.fp

        # Lexmark MarkVision Professional 
	remove_file $HOME/.dt/types/Lexmark_mvp.fp
	remove_file /etc/dt/appconfig/types/$LANG/Lexmark_mvp.fp
	remove_file $HOME/.dt/types/mv_pro.fp
	remove_file /etc/dt/appconfig/types/$LANG/mv_pro.fp

        # IBM MarkVision Professional 
	remove_file $HOME/.dt/types/ibm_mv_pro.fp
	remove_file /etc/dt/appconfig/types/$LANG/ibm_mv_pro.fp

        # Lexmark Enhanced Printer Drivers
	remove_file $HOME/.dt/types/Lexmark_print.fp
	remove_file /etc/dt/appconfig/types/$LANG/Lexmark_print.fp
	remove_file $HOME/.dt/types/LexmarkApp.dt	
	remove_file /etc/dt/appconfig/types/$LANG/LexmarkApp.dt
	remove_file $HOME/.dt/types/LexmarkAppAix.dt	
	remove_file /etc/dt/appconfig/types/$LANG/LexmarkAppAix.dt

        # OEM Enhanced Printer Drivers
	remove_file $HOME/.dt/types/MVprint.fp
	remove_file /etc/dt/appconfig/types/$LANG/MVprint.fp
	remove_file $HOME/.dt/types/MVprintApp.dt	
	remove_file /etc/dt/appconfig/types/$LANG/MVprintApp.dt
	remove_file $HOME/.dt/types/MVprintAppAix.dt	
	remove_file /etc/dt/appconfig/types/$LANG/MVprintAppAix.dt

        # Print Drivers for UNIX & Linux Systems
	remove_file $HOME/.dt/types/lex_vision_print.fp
	remove_file /etc/dt/appconfig/types/$LANG/lex_vision_print.fp
	remove_file $HOME/.dt/types/lex_print_drivers.fp
	remove_file /etc/dt/appconfig/types/$LANG/lex_print_drivers.fp

        # IBM Print Drivers for UNIX & Linux Systems
	remove_file $HOME/.dt/types/ibm_print_drivers.fp
	remove_file /etc/dt/appconfig/types/$LANG/ibm_print_drivers.fp

	# Generic Print Drivers for UNIX & Linux Systems
	remove_file $HOME/.dt/types/gen_print_drivers.fp
	remove_file /etc/dt/appconfig/types/$LANG/gen_print_drivers.fp

        # Dell Print Drivers for UNIX & Linux Systems
        remove_file $HOME/.dt/types/dell_print_drivers.fp
        remove_file /etc/dt/appconfig/types/$LANG/dell_print_drivers.fp

        # Images
	remove_file /etc/dt/appconfig/icons/$LANG/markvision.bmp 
	remove_file /etc/dt/appconfig/icons/$LANG/markvision.xpm
	remove_file /etc/dt/appconfig/icons/$LANG/details.bmp
	remove_file /etc/dt/appconfig/icons/$LANG/details.xpm

        # Old Files, No longer used. Clean up.
	remove_file $HOME/.dt/types/dtwm.fp
	remove_file /etc/dt/appconfig/types/$LANG/dtwm.fp
	remove_file /usr/dt/lib/xutil.sh
	remove_file /usr/dt/bin/getpdd
	remove_file /usr/dt/bin/sniff


        # The remaining section is no longer used.  We need to restore if needed.
        if [ -f $HOME/.dt/types/print.dt ]; then
	   remove_file $HOME/.dt/types/print.dt 
           ${MOVE_CMD} $HOME/.dt/types/print.dt.lex $HOME/.dt/types/print.dt
        fi

	if [ -f /etc/dt/appconfig/types/$LANG/print.dt.lex ]; then
	   ${CP_CMD} /etc/dt/appconfig/types/$LANG/print.dt.lex /etc/dt/appconfig/types/$LANG/print.dt 2>/dev/null
	   remove_file /etc/dt/appconfig/types/$LANG/print.dt.lex
	fi

	if [ -f /usr/dt/bin/dtlp.lex ]; then
	   ${CP_CMD} /usr/dt/bin/dtlp.lex /usr/dt/bin/dtlp 2>/dev/null
	   remove_file /usr/dt/bin/dtlp.lex
	fi	

}

cleanup_appmanager()
{
    	package="${1}"
        case ${package} in
        drivers)
		if [ -d /etc/dt/appconfig/appmanager/$LANG/Lexmark ];then
	           ${RM_CMD} -f -r /etc/dt/appconfig/appmanager/$LANG/Lexmark
                fi
		if [ -d /etc/dt/appconfig/appmanager/$LANG/Enhanced_Drivers ];then
	           ${RM_CMD} -f -r /etc/dt/appconfig/appmanager/$LANG/Enhanced_Drivers
                fi
                ;;
	mvp)
		if [ -d /etc/dt/appconfig/appmanager/$LANG/MarkVision_Pro ];then
	           ${RM_CMD} -f -r /etc/dt/appconfig/appmanager/$LANG/Markvision_Pro
                fi
                ;;
	ibmmvp)
		if [ -d /etc/dt/appconfig/appmanager/$LANG/IBM_MarkVision_Pro ];then
	           ${RM_CMD} -f -r /etc/dt/appconfig/appmanager/$LANG/IBM_Markvision_Pro
                fi
                ;;
        lexdrv)
		if [ -d /etc/dt/appconfig/appmanager/$LANG/Lexmark_Print_Drivers ];then
	           ${RM_CMD} -f -r /etc/dt/appconfig/appmanager/$LANG/Lexmark_Print_Drivers
                fi
                ;;
        ibmdrv)
		if [ -d /etc/dt/appconfig/appmanager/$LANG/IBM_Print_Drivers ];then
	           ${RM_CMD} -f -r /etc/dt/appconfig/appmanager/$LANG/IBM_Print_Drivers
                fi
                ;;
        gendrv)
                if [ -d /etc/dt/appconfig/appmanager/$LANG/Print_Drivers ];then
                   ${RM_CMD} -f -r /etc/dt/appconfig/appmanager/$LANG/Print_Drivers
                fi
                ;;
        delldrv)
		if [ -d /etc/dt/appconfig/appmanager/$LANG/Dell_Print_Drivers ];then
	           ${RM_CMD} -f -r /etc/dt/appconfig/appmanager/$LANG/Dell_Print_Drivers
                fi
                ;;
        esac
}

unintegrate ()
{
	lpkgname="${1}"
        lpkgpath="${2}"
        lpkgshort="${3}"

        if [ -d "${lpkgpath}" ];then
				 ${ECHO_CMD}
           ${ECHO_CMD} "Removing ${lpkgname} from the CDE Desktop."  
	   /usr/dt/bin/dtappintegrate -s ${lpkgpath} -u

				 ${ECHO_CMD}
        else
           # Package may have been already removed before uninstalling mark2cde, 
           # Lets clean up if we can.
           cleanup_appmanager ${lpkgshort}
        fi
}

Delete1()
{
	unintegrate "Enhanced Printer Drivers" "${MARKPATH}" drivers
	unintegrate "MarkVision Professional" "${MVPPATH}" mvp
	unintegrate "IBM MarkVision Professional" "${IBMMVPPATH}" ibmmvp
	unintegrate "Lexmark Print Drivers for UNIX & LINUX Systems" "${LEXDRVPATH}" lexdrv
	unintegrate "IBM Print Drivers for UNIX & LINUX Systems" "${IBMDRVPATH}" ibmdrv
	unintegrate "Print Drivers for UNIX & LINUX Systems" "${GENDRVPATH}" gendrv
	unintegrate "Dell Print Drivers for UNIX & LINUX Systems" "${DELLDRVPATH}" delldrv

        if [ -d /var/dt/appconfig/appmanager/$DTUSERSESSION/Lexmark ]; then
	       ${RM_CMD} -f -r /var/dt/appconfig/appmanager/$DTUSERSESSION/Lexmark
        fi

        if [ -d /var/dt/appconfig/appmanager/$DTUSERSESSION/Enhanced_Drivers ]; then
	       ${RM_CMD} -f -r /var/dt/appconfig/appmanager/$DTUSERSESSION/Enhanced_Drivers
        fi

        if [ -d /var/dt/appconfig/appmanager/$DTUSERSESSION/MarkVision_Pro ]; then
	       ${RM_CMD} -f -r /var/dt/appconfig/appmanager/$DTUSERSESSION/MarkVision_Pro
        fi
        
        if [ -d /var/dt/appconfig/appmanager/$DTUSERSESSION/IBM_MarkVision_Pro ]; then
	       ${RM_CMD} -f -r /var/dt/appconfig/appmanager/$DTUSERSESSION/IBM_MarkVision_Pro
        fi

        if [ -d /var/dt/appconfig/appmanager/$DTUSERSESSION/Lexmark_Print_Drivers ]; then
	       ${RM_CMD} -f -r /var/dt/appconfig/appmanager/$DTUSERSESSION/Lexmark_Print_Drivers
        fi

        if [ -d /var/dt/appconfig/appmanager/$DTUSERSESSION/IBM_Print_Drivers ]; then
	       ${RM_CMD} -f -r /var/dt/appconfig/appmanager/$DTUSERSESSION/IBM_Print_Drivers
        fi

        if [ -d /var/dt/appconfig/appmanager/$DTUSERSESSION/Print_Drivers ]; then
               ${RM_CMD} -f -r /var/dt/appconfig/appmanager/$DTUSERSESSION/Print_Drivers
        fi

        if [ -d /var/dt/appconfig/appmanager/$DTUSERSESSION/Dell_Print_Drivers ]; then
	       ${RM_CMD} -f -r /var/dt/appconfig/appmanager/$DTUSERSESSION/Dell_Print_Drivers
        fi
	CDE_HOST=`${ECHO_CMD} $DTUSERSESSION | ${AWK_CMD} -F- '{print $2}'`
        if [ "$CDE_HOST" = `${UNAME_CMD} -n`  ]; then
		/usr/dt/bin/dtaction RestorePanel
	else 
                ${ECHO_CMD} 
		${ECHO_CMD} You may run this shell script remotely, but restoring 
                ${ECHO_CMD} the current CDE front panel can only be done on the 
                ${ECHO_CMD} console. You must manually restart your Workspace
                ${ECHO_CMD} Manager.
				 ${ECHO_CMD}
	fi 

        restore_dt_types
}


copy_datatype_file()
{

   # Copy datatype file. 

	 ${ECHO_CMD}
   if   [ -f $DELLDRVPATH/dt/appconfig/types/C/${datatype_file} ];then

                ${ECHO_CMD} "Using Dell Print Drivers' Datatype file"
                ${CP_CMD} $DELLDRVPATH/dt/appconfig/types/C/${datatype_file} /etc/dt/appconfig/types/$LANG 2>/dev/null
                ${CP_CMD} $DELLDRVPATH/dt/appconfig/types/C/${datatype_file} $HOME/.dt/types 2>/dev/null

   elif   [ -f $GENDRVPATH/dt/appconfig/types/C/${datatype_file} ];then

                ${ECHO_CMD} "Using Print Drivers' Datatype file"
                ${CP_CMD} $GENDRVPATH/dt/appconfig/types/C/${datatype_file} /etc/dt/appconfig/types/$LANG 2>/dev/null
                ${CP_CMD} $GENDRVPATH/dt/appconfig/types/C/${datatype_file} $HOME/.dt/types 2>/dev/null

   elif   [ -f $LEXDRVPATH/dt/appconfig/types/C/${datatype_file} -o -f $IBMDRVPATH/dt/appconfig/types/C/${datatype_file} ];then

           if   [ -f $IBMDRVPATH/dt/appconfig/types/C/${datatype_file} ];then
                ${ECHO_CMD} "Using IBM Print Drivers' Datatype file"
                ${CP_CMD} $IBMDRVPATH/dt/appconfig/types/C/${datatype_file} /etc/dt/appconfig/types/$LANG 2>/dev/null
                ${CP_CMD} $IBMDRVPATH/dt/appconfig/types/C/${datatype_file} $HOME/.dt/types 2>/dev/null
           else
                ${ECHO_CMD} "Using Lexmark Print Drivers' Datatype file"
                ${CP_CMD} $LEXDRVPATH/dt/appconfig/types/C/${datatype_file} /etc/dt/appconfig/types/$LANG 2>/dev/null
                ${CP_CMD} $LEXDRVPATH/dt/appconfig/types/C/${datatype_file} $HOME/.dt/types 2>/dev/null
           fi

   elif [ -f "$MVPPATH/dt/appconfig/types/C/${datatype_file}" -o -f $IBMMVPPATH/dt/appconfig/types/C/${datatype_file} ];then

           if [ -f $MVPPATH/dt/appconfig/types/C/${datatype_file} ]; then
                ${ECHO_CMD} "Using MarkVision Professional's Datatype file"
                ${CP_CMD} $MVPPATH/dt/appconfig/types/C/${datatype_file} /etc/dt/appconfig/types/$LANG 2>/dev/null
                ${CP_CMD} $MVPPATH/dt/appconfig/types/C/${datatype_file} $HOME/.dt/types 2>/dev/null
           else
                ${ECHO_CMD} "Using IBM MarkVision Professional's Datatype file"
                ${CP_CMD} $IBMMVPPATH/dt/appconfig/types/C/${datatype_file} /etc/dt/appconfig/types/$LANG 2>/dev/null
                ${CP_CMD} $IBMMVPPATH/dt/appconfig/types/C/${datatype_file} $HOME/.dt/types 2>/dev/null
           fi

   else

           ${ECHO_CMD} "Using MarkVision Native Datatype file"
           if [ -f $MARKPATH/dt/appconfig/types/C/${datatype_file} ]; then
                ${CP_CMD} $MARKPATH/dt/appconfig/types/C/${datatype_file} /etc/dt/appconfig/types/$LANG 2>/dev/null
                ${CP_CMD} $MARKPATH/dt/appconfig/types/C/${datatype_file} $HOME/.dt/types 2>/dev/null
           fi
   fi
       
}

#######################################################
#
#  This function displays the CDE Utility Menu.
#
#######################################################
display_menu ()
{
   continue="no"

	${ECHO_CMD}
   ${ECHO_CMD} "CDE Menu Utility"
   ${ECHO_CMD} 
   ${ECHO_CMD} "  1. Install Menu Entries."
   ${ECHO_CMD} "  2. Remove Menu Entries."
   ${ECHO_CMD} "  3. Exit."
	 ${ECHO_CMD}
   ${PRINTF_CMD} "Enter your choice : [3] "
   while [ "${continue}" = "no" ]
   do
       read ans
       if   [ "${ans}" = "1" -o "${ans}" = "2" -o "${ans}" = "3" ];then
            continue="yes"
       elif [ "${ans}" = "" ];then
            continue="yes"
       else
            ${ECHO_CMD} 
            ${PRINTF_CMD} "Invalid choice. Enter your choice : "
       fi
   done

   if   [ "${ans}" = "1" ];then
        run_type=install
   elif [ "${ans}" = "2" ];then
        run_type=remove
   else
	 	${ECHO_CMD}
        exit 0
   fi
}


##########################################################################
#
#
# main shell
#
#
##########################################################################

MARKPATH=/usr/markvision;export MARKPATH
MVPPATH=/usr/mvp;export MVPPATH
IBMMVPPATH=/usr/ibmmvp;export IBMMVPPATH
LEXDRVPATH=/usr/lexprint;export LEXDRVPATH
IBMDRVPATH=/usr/ibmprint;export IBMDRVPATH
GENDRVPATH=/usr/genprint;export GENDRVPATH
DELLDRVPATH=/usr/dellprint;export DELLDRVPATH
PATH=$PATH:/usr/ucb:/usr/bin:/usr/dt/bin:/usr/sbin;export PATH


if [ "$LANG" = "" ]; then
   ${ECHO_CMD} "Language variable is null, it is going to use the default C"
   export LANG=C 
fi

if [ "$USER" = "" ]; then
   ${ECHO_CMD} "USER variable is null, please set up your USER variable"
   exit 1
fi

if [ "$HOME" = "" ]; then
   ${ECHO_CMD} "HOME variable is null, please set up your HOME variable"
   exit 1
fi
  
USER_ID=`whoami`
if [ "$USER_ID" != "root" ] ; then 
   ${ECHO_CMD} "You must be root to run $0!"
   exit 1
fi

if [ ! -d "/usr/dt" ] || [ ! -f "/usr/dt/bin/dtlogin" ]; then
   ${ECHO_CMD} "No CDE found on this system."
   exit 1
fi

#-- Display CDE Utility Menu
while getopts ird  arg
do
  case $arg in
    i) run_type=install
      ;;
    r|d) run_type=remove
      ;;
esac
done

if [ -z "$run_type" ];then
   display_menu
fi

if [ "${run_type}" = "remove" ];then
	Delete 
	Delete1
   ${ECHO_CMD} "Successfully removed CDE applications links."
   exit 0
else
#Create the links for system-wide MarkVision of CDE or user MarkVision

ICONS=/etc/dt/appconfig/icons/$LANG


if [ ! -d $ICONS ]; then
   ${MKDIR_CMD} -p $ICONS 
   ${CHMOD_CMD} 755 $ICONS
   ${CHOWN_CMD} root $ICONS
fi

# Create the actions and applications links for system-wide MarkVision of CDE

TYPES=/etc/dt/appconfig/types/$LANG

 
if [ ! -d $TYPES  ]; then
   ${MKDIR_CMD} -p $TYPES
   ${CHMOD_CMD} 755 $TYPES
   ${CHOWN_CMD} root $TYPES
fi

if [[ -f $TYPES/Lexmark_print.fp    || -f $TYPES/Lexmark_client.fp    || 
      -f $TYPES/Lexmark_mvp.fp      || -f $TYPES/mv_pro.fp            || 
      -f $TYPES/ibm_mv_pro.fp       || -f $TYPES/lex_print_drivers.fp ||
      -f $TYPES/lex_vision_print.fp || -f $TYPES/ibm_print_drivers.fp || -f $TYPES/gen_print_drivers.fp ]]; then

   if [ ! -d $HOME/.dt/types ]; then
      ${MKDIR_CMD} -p $HOME/.dt/types
      ${CHMOD_CMD} 755 $HOME/.dt/types
      ${CHOWN_CMD} $USER $HOME/.dt/types
   fi	

   Delete
   restore_dt_types

   ${ECHO_CMD} 'Updating CDE....'
		
   if [  `${UNAME_CMD}` = "AIX" ]; then
      datatype_file="LexmarkAppAix.dt"
   else
      datatype_file="LexmarkApp.dt"
   fi

   copy_datatype_file
	
   if [ -f $MARKPATH/dt/appconfig/types/C/Lexmark_client.fp ]; then
      ${CP_CMD} $MARKPATH/dt/appconfig/types/C/Lexmark_client.fp /etc/dt/appconfig/types/$LANG/Lexmark_client.fp 2>/dev/null
   fi

   if [ -f $MARKPATH/dt/appconfig/types/C/Lexmark_mvp.fp ]; then
      ${CP_CMD} $MARKPATH/dt/appconfig/types/C/Lexmark_mvp.fp /etc/dt/appconfig/types/$LANG/Lexmark_mvp.fp 2>/dev/null
   fi

   if [ -f $MVPPATH/dt/appconfig/types/C/mv_pro.fp ]; then
      ${CP_CMD} $MVPPATH/dt/appconfig/types/C/mv_pro.fp /etc/dt/appconfig/types/$LANG/mv_pro.fp 2>/dev/null
   fi

   if [ -f $IBMMVPPATH/dt/appconfig/types/C/ibm_mv_pro.fp ]; then
      ${CP_CMD} $IBMMVPPATH/dt/appconfig/types/C/ibm_mv_pro.fp /etc/dt/appconfig/types/$LANG/ibm_mv_pro.fp 2>/dev/null
   fi

   if [ -f $LEXDRVPATH/dt/appconfig/types/C/lex_print_drivers.fp ]; then
      ${CP_CMD} $LEXDRVPATH/dt/appconfig/types/C/lex_print_drivers.fp /etc/dt/appconfig/types/$LANG/lex_print_drivers.fp 2>/dev/null
   fi

   if [ -f $IBMDRVPATH/dt/appconfig/types/C/ibm_print_drivers.fp ]; then
      ${CP_CMD} $IBMDRVPATH/dt/appconfig/types/C/ibm_print_drivers.fp /etc/dt/appconfig/types/$LANG/ibm_print_drivers.fp 2>/dev/null
   fi

   if [ -f $GENDRVPATH/dt/appconfig/types/C/gen_print_drivers.fp ]; then
      ${CP_CMD} $GENDRVPATH/dt/appconfig/types/C/gen_print_drivers.fp /etc/dt/appconfig/types/$LANG/gen_print_drivers.fp 2>/dev/null
   fi

   if [ -f $DELLDRVPATH/dt/appconfig/types/C/dell_print_drivers.fp ]; then
      ${CP_CMD} $DELLDRVPATH/dt/appconfig/types/C/dell_print_drivers.fp /etc/dt/appconfig/types/$LANG/dell_print_drivers.fp 2>/dev/null
   fi
   if [ -f $MARKPATH/dt/appconfig/types/C/Lexmark_print.fp ]; then
      ${CP_CMD} $MARKPATH/dt/appconfig/types/C/Lexmark_print.fp /etc/dt/appconfig/types/$LANG/Lexmark_print.fp 2>/dev/null
   fi

else

   if [  `${UNAME_CMD}` = "AIX" ]; then
      datatype_file="LexmarkAppAix.dt"
   else
      datatype_file="LexmarkApp.dt"
   fi

   Delete
   restore_dt_types

   ${ECHO_CMD} 'Installing applications into the CDE Desktop ...'
  
   # Remove existing mark2cde
   if [ -f /usr/bin/mark2cde ]; then
      ${RM_CMD} -f /usr/bin/mark2cde
   fi
	
   if [ ! -d $HOME/.dt/types ]; then
      ${MKDIR_CMD} -p $HOME/.dt/types
      ${CHMOD_CMD} 755 $HOME/.dt/types
      ${CHOWN_CMD} $USER $HOME/.dt/types
   fi	

   if [ -f $MARKPATH/dt/appconfig/types/C/Lexmark_client.fp ]; then
      ${CP_CMD} $MARKPATH/dt/appconfig/types/C/Lexmark_client.fp /etc/dt/appconfig/types/$LANG/Lexmark_client.fp  2>/dev/null
   fi

   if [ -f $MARKPATH/dt/appconfig/types/C/Lexmark_mvp.fp ]; then
      ${CP_CMD} $MARKPATH/dt/appconfig/types/C/Lexmark_mvp.fp /etc/dt/appconfig/types/$LANG/Lexmark_mvp.fp  2>/dev/null
   fi

   if [ -f $MVPPATH/dt/appconfig/types/C/mv_pro.fp ]; then
      ${CP_CMD} $MVPPATH/dt/appconfig/types/C/mv_pro.fp /etc/dt/appconfig/types/$LANG/mv_pro.fp 2>/dev/null
   fi

   if [ -f $IBMMVPPATH/dt/appconfig/types/C/ibm_mv_pro.fp ]; then
      ${CP_CMD} $IBMMVPPATH/dt/appconfig/types/C/ibm_mv_pro.fp /etc/dt/appconfig/types/$LANG/ibm_mv_pro.fp 2>/dev/null
   fi

   if [ -f $LEXDRVPATH/dt/appconfig/types/C/lex_print_drivers.fp ]; then
      ${CP_CMD} $LEXDRVPATH/dt/appconfig/types/C/lex_print_drivers.fp /etc/dt/appconfig/types/$LANG/lex_print_drivers.fp 2>/dev/null
   fi

   if [ -f $IBMDRVPATH/dt/appconfig/types/C/ibm_print_drivers.fp ]; then
      ${CP_CMD} $IBMDRVPATH/dt/appconfig/types/C/ibm_print_drivers.fp /etc/dt/appconfig/types/$LANG/ibm_print_drivers.fp 2>/dev/null
   fi

   if [ -f $GENDRVPATH/dt/appconfig/types/C/gen_print_drivers.fp ]; then
      ${CP_CMD} $GENDRVPATH/dt/appconfig/types/C/gen_print_drivers.fp /etc/dt/appconfig/types/$LANG/gen_print_drivers.fp 2>/dev/null
   fi

   if [ -f $DELLDRVPATH/dt/appconfig/types/C/dell_print_drivers.fp ]; then
      ${CP_CMD} $DELLDRVPATH/dt/appconfig/types/C/dell_print_drivers.fp /etc/dt/appconfig/types/$LANG/dell_print_drivers.fp 2>/dev/null
   fi

   if [ -f $MARKPATH/dt/appconfig/types/C/Lexmark_print.fp ]; then
      ${CP_CMD} $MARKPATH/dt/appconfig/types/C/Lexmark_print.fp /etc/dt/appconfig/types/$LANG/Lexmark_print.fp  2>/dev/null
   fi
   
   copy_datatype_file
	
   if [ ! -f $HOME/.dt/types/Lexmark_client.fp ]; then
      if [ -f $MARKPATH/dt/appconfig/types/C/Lexmark_client.fp ]; then	
         ${CP_CMD} $MARKPATH/dt/appconfig/types/C/Lexmark_client.fp $HOME/.dt/types/Lexmark_client.fp  2>/dev/null
      fi
   fi

   if [ ! -f $HOME/.dt/types/Lexmark_print.fp ]; then
      if [ -f $MARKPATH/dt/appconfig/types/C/Lexmark_print.fp ]; then	
         ${CP_CMD} $MARKPATH/dt/appconfig/types/C/Lexmark_print.fp $HOME/.dt/types/Lexmark_print.fp  2>/dev/null
      fi
   fi

   if [ ! -f $HOME/.dt/types/Lexmark_mvp.fp ]; then
      if [ -f $MARKPATH/dt/appconfig/types/C/Lexmark_mvp.fp ]; then
         ${CP_CMD} $MARKPATH/dt/appconfig/types/C/Lexmark_mvp.fp $HOME/.dt/types/Lexmark_mvp.fp  2>/dev/null
      fi
   fi
   
   if [ ! -f $HOME/.dt/types/ibm_mv_pro.fp ]; then
      if [ -f $IBMMVPPATH/dt/appconfig/types/C/ibm_mv_pro.fp ]; then
         ${CP_CMD} $IBMMVPPATH/dt/appconfig/types/C/ibm_mv_pro.fp $HOME/.dt/types  2>/dev/null
      fi
   fi

   if [ ! -f $HOME/.dt/types/mv_pro.fp ]; then
      if [ -f $MVPPATH/dt/appconfig/types/C/mv_pro.fp ]; then
         ${CP_CMD} $MVPPATH/dt/appconfig/types/C/mv_pro.fp $HOME/.dt/types  2>/dev/null
      fi
   fi

   if [ ! -f $HOME/.dt/types/lex_print_drivers.fp ]; then
      if [ -f $LEXDRVPATH/dt/appconfig/types/C/lex_print_drivers.fp ]; then
         ${CP_CMD} $LEXDRVPATH/dt/appconfig/types/C/lex_print_drivers.fp $HOME/.dt/types  2>/dev/null
      fi
   fi

   if [ ! -f $HOME/.dt/types/ibm_print_drivers.fp ]; then
      if [ -f $IBMDRVPATH/dt/appconfig/types/C/ibm_print_drivers.fp ]; then
         ${CP_CMD} $IBMDRVPATH/dt/appconfig/types/C/ibm_print_drivers.fp $HOME/.dt/types  2>/dev/null
      fi
   fi

   if [ ! -f $HOME/.dt/types/gen_print_drivers.fp ]; then
      if [ -f $GENDRVPATH/dt/appconfig/types/C/gen_print_drivers.fp ]; then
         ${CP_CMD} $GENDRVPATH/dt/appconfig/types/C/gen_print_drivers.fp $HOME/.dt/types  2>/dev/null
      fi
   fi

   if [ ! -f $HOME/.dt/types/dell_print_drivers.fp ]; then
      if [ -f $DELLDRVPATH/dt/appconfig/types/C/dell_print_drivers.fp ]; then
         ${CP_CMD} $DELLDRVPATH/dt/appconfig/types/C/dell_print_drivers.fp $HOME/.dt/types  2>/dev/null
      fi
   fi

fi

if [ -f $MARKPATH/dt/appconfig/icons/C/markvision.bmp ] ; then
   ${CP_CMD} $MARKPATH/dt/appconfig/icons/C/markvision.bmp /etc/dt/appconfig/icons/$LANG
fi

if [ -f $MARKPATH/dt/appconfig/icons/C/markvision.xpm ]; then
   ${CP_CMD} $MARKPATH/dt/appconfig/icons/C/markvision.xpm /etc/dt/appconfig/icons/$LANG
fi

if [ -f $MARKPATH/dt/appconfig/icons/C/details.bmp ] ; then	
   ${CP_CMD} $MARKPATH/dt/appconfig/icons/C/details.bmp /etc/dt/appconfig/icons/$LANG
fi

if [ -f $MARKPATH/dt/appconfig/icons/C/details.xpm ] ; then
   ${CP_CMD} $MARKPATH/dt/appconfig/icons/C/details.xpm /etc/dt/appconfig/icons/$LANG
fi

if [ -d $HOME/.dt/types ]; then
   ${CHMOD_CMD} 777 $HOME/.dt/types/*
   if [ -d $HOME/.dt/types/fp_dynamic ]; then
			FP_FILES=`${LS_CMD} $HOME/.dt/types/fp_dynamic/*.fp 2>/dev/null | ${WC_CMD} -l`
			if [ $FP_FILES != '0' ]; then
				${CP_CMD} $HOME/.dt/types/fp_dynamic/*.fp $HOME/.dt/types/ 2>/dev/null
				${RM_CMD} -f $HOME/.dt/types/fp_dynamic/*.fp 2>/dev/null
			fi
		fi
	fi

	if [ -d $MARKPATH ]; then
		${ECHO_CMD}
		${ECHO_CMD} "Installing Enhanced Printer Driver into the CDE Desktop."  
		/usr/dt/bin/dtappintegrate -s $MARKPATH
	fi
	if [ -d $MVPPATH ]; then
		${ECHO_CMD}
		${ECHO_CMD} "Installing MarkVision Professional into the CDE Desktop."  
		/usr/dt/bin/dtappintegrate -s $MVPPATH
	fi
	if [ -d $IBMMVPPATH ]; then
		${ECHO_CMD}
		${ECHO_CMD} "Installing IBM MarkVision Professional into the CDE Desktop."  
		/usr/dt/bin/dtappintegrate -s $IBMMVPPATH
	fi
	if [ -d $LEXDRVPATH ]; then
		${ECHO_CMD}
		${ECHO_CMD} "Installing Lexmark Print Drivers for UNIX & LINUX Systems into CDE."  
		/usr/dt/bin/dtappintegrate -s $LEXDRVPATH
	fi
	if [ -d $IBMDRVPATH ]; then
		${ECHO_CMD}
		${ECHO_CMD} "Installing IBM Print Drivers for UNIX & LINUX Systems into CDE."  
		/usr/dt/bin/dtappintegrate -s $IBMDRVPATH
	fi
        if [ -d $GENDRVPATH ]; then
                ${ECHO_CMD}
                ${ECHO_CMD} "Installing Print Drivers for UNIX & LINUX Systems into CDE."
                /usr/dt/bin/dtappintegrate -s $GENDRVPATH
        fi
	if [ -d $DELLDRVPATH ]; then
		${ECHO_CMD}
		${ECHO_CMD} "Installing Dell Print Drivers for UNIX & LINUX Systems into CDE."  
		/usr/dt/bin/dtappintegrate -s $DELLDRVPATH
	fi


	/usr/dt/bin/dtaction ReloadApps

	CDE_HOST=`${ECHO_CMD} $DTUSERSESSION | ${AWK_CMD} -F- '{print $2}'`
	if [ "$CDE_HOST" != `${UNAME_CMD} -n`  ]; then
		${ECHO_CMD}
		${ECHO_CMD} You may run this shell script remotely, but restoring
		${ECHO_CMD} the current CDE front panel can only be done on the
		${ECHO_CMD} console. You must manually restart your Workspace
		${ECHO_CMD} Manager.
		${ECHO_CMD}
	else
   # installs files and updates running CDE
   /usr/dt/bin/dtaction RestorePanel
fi

if [ -d $HOME/.dt/types ]; then
   FP_FILES=`${LS_CMD} $HOME/.dt/types/*.fp 2>/dev/null | ${WC_CMD} -l`
   if [ $FP_FILES != '0' ]; then
      if [ ! -d $HOME/.dt/types/fp_dynamic ]; then
          ${MKDIR_CMD} $HOME/.dt/types/fp_dynamic
          ${CHMOD_CMD} 755 $HOME/.dt/types/fp_dynamic
          ${CHOWN_CMD} $USER $HOME/.dt/type/fp_dynamic
      fi	
      ${CP_CMD} $HOME/.dt/types/*.fp $HOME/.dt/types/fp_dynamic 2>/dev/null
      ${RM_CMD} -f $HOME/.dt/types/*.fp 2>/dev/null
    fi
    ${CHMOD_CMD} 755 $HOME/.dt/types/*
fi

${ECHO_CMD}
${ECHO_CMD} "NOTE:"
${ECHO_CMD} "If there are icons missing from the personal printers' sub-panel, you"
${ECHO_CMD} "may have to re-logon for changes to take affect."
${ECHO_CMD}
 
fi 
exit 0

######################### End of Script ######################################## 
